commit 71a0cf699b6a2dc03abec53aeafab8b70db2bb07
Author: liuhongt <hongtao.liu@intel.com>
Date:   Tue Oct 29 02:09:39 2024 -0700

    Fix ICE due to subreg:us_truncate.
    
    Force_operand issues an ICE when input
    is (subreg:DI (us_truncate:V8QI)), it's probably because it's an
    invalid rtx, So refine backend patterns for that.
    
    gcc/ChangeLog:
    
            PR target/117318
            * config/i386/sse.md (*avx512vl_<code>v2div2qi2_mask_store_1):
            Rename to ..
            (avx512vl_<code>v2div2qi2_mask_store_1): .. this.
            (avx512vl_<code>v2div2qi2_mask_store_2): Change to
            define_expand.
            (*avx512vl_<code><mode>v4qi2_mask_store_1): Rename to ..
            (avx512vl_<code><mode>v4qi2_mask_store_1): .. this.
            (avx512vl_<code><mode>v4qi2_mask_store_2): Change to
            define_expand.
            (*avx512vl_<code><mode>v8qi2_mask_store_1): Rename to ..
            (avx512vl_<code><mode>v8qi2_mask_store_1): .. this.
            (avx512vl_<code><mode>v8qi2_mask_store_2): Change to
            define_expand.
            (*avx512vl_<code><mode>v4hi2_mask_store_1): Rename to ..
            (avx512vl_<code><mode>v4hi2_mask_store_1): .. this.
            (avx512vl_<code><mode>v4hi2_mask_store_2): Change to
            define_expand.
            (*avx512vl_<code>v2div2hi2_mask_store_1): Rename to ..
            (avx512vl_<code>v2div2hi2_mask_store_1): .. this.
            (avx512vl_<code>v2div2hi2_mask_store_2): Change to
            define_expand.
            (*avx512vl_<code>v2div2si2_mask_store_1): Rename to ..
            (avx512vl_<code>v2div2si2_mask_store_1): .. this.
            (avx512vl_<code>v2div2si2_mask_store_2): Change to
            define_expand.
            (*avx512f_<code>v8div16qi2_mask_store_1): Rename to ..
            (avx512f_<code>v8div16qi2_mask_store_1): .. this.
            (avx512f_<code>v8div16qi2_mask_store_2): Change to
            define_expand.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/i386/pr117318.c: New test.
    
    (cherry picked from commit bc0eeccf27a084461a2d5661e23468350acb43da)

diff --git a/gcc/testsuite/gcc.target/i386/pr117318.c b/gcc/testsuite/gcc.target/i386/pr117318.c
new file mode 100644
index 00000000000..3d316ad04cf
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr117318.c
@@ -0,0 +1,12 @@
+/* { dg-do compile } */
+/* { dg-options "-mavx512f -O" } */
+
+typedef __attribute__((__vector_size__ (64))) long long V;
+unsigned long long x;
+
+unsigned long long
+foo()
+{
+  __builtin_ia32_pmovusqb512mem_mask (&x, (V){8000000000000000}, 255);
+  return x;
+}

